package filter ; 

import java.util.*;
import java.rmi.*;
import java.rmi.server.*;
import server.*;
public class CSearchFilterPipe extends UnicastRemoteObject 
                        implements ISearchFilterPipe
{
	 public static Vector upFilterVector = new Vector();
	 public static Vector downFilterVector = new Vector() ; 

	 public CSearchFilterPipe() throws RemoteException
	 {
	 }
	 public  boolean searchUp (ISearch se, Object[] args,   Result  res)
	 {
		 
		  
		  ISearchFilter filt ; 
		  boolean flag = true ; 
		  for (Enumeration e =  upFilterVector.elements() ;
					e.hasMoreElements() && flag == true;
			  )	
		  {
			   
            System.out.println("executing up filters") ; 
			   filt = (ISearchFilter) e.nextElement(); 
			   flag = flag &&   filt.searchUp(se , args , res);
		  }
		  return flag ;
	 }

 public  void searchDown( Result  res)
	 {
		  ISearchFilter filt ; 
		  boolean flag = true ; 
		  for (Enumeration e =  downFilterVector.elements() ;
					e.hasMoreElements() && flag == true;
			  )	{

                  System.out.println("executing down filters") ; 
			   filt = (ISearchFilter) e.nextElement(); 
			   filt.searchDown(res);
		  }
	 }
}
