package client;

import java.rmi.*;
import server.ISearch;

public class SearchClient {

    public static void main(String args[]) {
        if (System.getSecurityManager() == null) {
            System.setSecurityManager(new RMISecurityManager());
        }
        try {
            String name = "//" + args[0] + "/SearchEngine";
			ISearch se  = (ISearch) Naming.lookup(name);
			String query = "rmi, distributed " ; 
		    System.out.println(	se.search(query)) ; 
		
		} catch (Exception e) {
            System.err.println("ISearch exception: " + e.getMessage());
            e.printStackTrace();
        }
    }    
}
